/********************************************************************
 *  Copyright (c) 2003, InfiniTec IT Soluions						*
 *																	*
 *	This program is free software; you can redistribute it			*
 *	and/or modify it under the terms of the GNU General Public		*
 *	License as published by the Free Software Foundation;			*
 *	either version 2 of the License, or (at your option) any		*
 *	later version. This program is distributed in the hope that		*
 *	it will be useful, but WITHOUT ANY WARRANTY; without even the	*	
 *	implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR *
 *	PURPOSE. See the GNU General Public License for more details.   * 
 ********************************************************************/

using System;
using System.Net;
using InfiniTec.SystemUtilities;
using System.Globalization;

namespace MagicPacketSender
{
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	class Class
	{
		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main(string[] args)
		{
			string[] destination;
			byte[] macAddress;
			IPAddress subnet;
			int i;

			Console.WriteLine("MagicPacketSender 1.0 - (c) 2003, InfiniTec IT Solutions\n");
			subnet = null;

			try 
			{
				try 
				{
					destination = args[0].Split(new char[] {':', '-'});

					if (args.Length == 2) 
					{
						subnet = IPAddress.Parse(args[1]);
					}
				
					macAddress = new byte[6];

					for (i=0; i<6; i++) 
					{
						macAddress[i] = byte.Parse(destination[i], NumberStyles.AllowHexSpecifier);
					}
				}
				catch (Exception e) 
				{
					throw new ArgumentException("One or more of the supplied arguments were invalid.", e);
				}
				if (subnet == null) MagicPacket.Send(macAddress);
				else MagicPacket.Send(subnet, macAddress);

				Console.WriteLine("Magic packet was successfully sent.");
			}
			catch (ArgumentException e)
			{
				Console.WriteLine(e.Message);
				Console.WriteLine("Usage: MagicPacketSender MACAddress [Subnet]");
				Console.WriteLine("Where:");
				Console.WriteLine("  MACAddress:\tThe MACAddress of the computer to send the packet to.");
				Console.WriteLine("\t\tMust be in the form xx-xx-xx-xx-xx-xx.");
				Console.WriteLine("  Subnet:\t[Optional] The subnet to send the magic packet to.");
				Console.WriteLine("\t\tNote, that although a directed broadcast is used, not all");
				Console.WriteLine("\t\trouters forward these packets.");
				Console.WriteLine("\n\n");
			}
			catch (Exception e) 
			{
				Console.WriteLine("An Error occured while sending the magic packet.");
				Console.WriteLine("The error was: ");
				Console.WriteLine("\t" + e.Message);
				Console.WriteLine("\n\n");
			}
		}
	}
}
